/* Autor: Leandro Bernsmuller
Declara janela.cpp */



class CJanela {

public:

   // informacao sobre o aplicativo windows e janela
   HWND m_hWnd;         // janela da aplicacao
   BOOL m_bMinimizou;   // T - estah minimizado

   // aponta para um conjunto de bitmaps que a janela pode exibir
   CGr* m_poBmps;
   BOOL m_bExibir [ MAX_BMPS ];  // quais bitmaps exibir
                                 // (TRUE - exibe / FALSE - nao exibe)

   BOOL mCria ( DWORD dwMenu, char* szTitulo, HINSTANCE hInstance );
   void mDestroi ();
   void mExibe ( int nCmdShow );
   void mAlteraTamanhoPosicaoJanela ( int nComo, int nXI, int nYI, int nX, int nY );
   void mIncluiBmps ( CGr& oBmps );
   void mRedesenha ();

   // tratam mensagens do Windows
   BOOL mTrataMensagensWindows ( HWND& hWnd, UINT& uMsg, WPARAM& wParam,
                                 LPARAM& lParam );
   void mWinAlteraVideo ( HWND& hWnd, UINT& uMsg,
                                       WPARAM& wParam, LPARAM& lParam );
   void mWinAlteraTamanhoJanela ( HWND& hWnd, UINT& uMsg,
                                       WPARAM& wParam, LPARAM& lParam );
   void mWinAtivo ( HWND& hWnd, UINT& uMsg,
                                       WPARAM& wParam, LPARAM& lParam );
};
